<?php
/**
 * hue.php - Script to allow the Admin to index the albums for most domiment hue in the pictures
 *
 * See README for installation and usage.
 *
 *
 * @copyright Aditya Mooley <adityamooley@sanisoft.com>, Tarique Sani <tarique@sanisoft.com>
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 *
 */
define('IN_COPPERMINE', true);
require('include/init.inc.php');
if (!GALLERY_ADMIN_MODE) cpg_die(ERROR, 'Access denied', __FILE__, __LINE__);
function RGBtoHSV($r, $g, $b)
{
    $mn=$r;
    $mx=$r;
    $maxVal=0;

    if ($g > $mx){
      $mx=$g;
      $maxVal=1;
    }

    if ($b > $mx){
      $mx=$b;
      $maxVal=2;
    }

    if ($g < $mn)
      $mn=$g;

    if ($b < $mn)
      $mn=$b;

    $delta = $mx -  $mn;

    $v = $mx;
    if( $mx != 0 )
      $s = ceil(($delta / $mx) * 255);
    else
    {
      $s = 0;
      $h = 0;
    }
    if ($s == 0.0)
    {
      $h=-1;
    }
    else
    {
      switch ($maxVal)
      {
      case 0:{$h = ( $g - $b ) / $delta;break;}         // yel < h < mag
      case 1:{$h = 2 + ( $b - $r ) / $delta;break;}     // cyan < h < yel
      case 2:{$h = 4 + ( $r - $g ) / $delta;break;}     // mag < h < cyan
      }
    }

    $h *= 60;
    if( $h < 0 ) $h += 360;

    return array($h,$s,$v);
}
$pid = (int)$_GET["pid"];
$skip = $_GET["skip"];
$query = "SELECT pid, aid, filepath, filename FROM {$CONFIG['TABLE_PICTURES']} WHERE pid = '$pid'";
$result = mysql_query($query);
if (mysql_num_fields($result) > 0) {
  $row = mysql_fetch_array($result);
  $fileExt = substr($row["filename"], strrpos($row["filename"], ".")+1);
  if ($fileExt != "jpg" && $fileExt != "jpeg") {
    /**
     * Image is not jpeg. Show the NA image.
     */
    $fileName = "images/up_na.gif";
    flush();
  }
  /**
   * If user has asked to skip the duplicate files, check the pid in the colors table and show DP image if duplicate
   */
  $duplicate = false;
  if ($skip == "skip") {
    $query = "SELECT pid FROM {$CONFIG['TABLE_PREFIX']}colors WHERE pid = '$pid'";
    $result1 = mysql_query($query);
    if (mysql_num_rows($result1) > 0) {
      /**
       * Show DP image.
       */
      $fileName = "images/up_dup.gif";
      $duplicate = true;
      flush();
    }
  }
  if (!$duplicate) {
    $im = $CONFIG["fullpath"].$row["filepath"]."thumb_".$row["filename"];
    flush();
    $simg=ImageCreateFromJPEG($im);
    $palette = imagetruecolortopalette($simg, false, 256);

    $Xcounter = imagesx($simg) - 1;
    $LoopCount = 0;

    $totalS = 0;
    $totalV = 0;
    set_time_limit(300);
    while($Xcounter >= 0){
      $Ycounter = imagesy($simg) - 1;
      while($Ycounter >= 0){
        $pixel = imagecolorat($simg, $Xcounter, $Ycounter);
        $recolorarray = imagecolorsforindex($simg, $pixel);
        $r = $recolorarray['red'];
        $g = $recolorarray['green'];
        $b = $recolorarray['blue'];
        list($hue, $s, $v) = RGBtoHSV($r, $g, $b);

        if ($s > 96 & $v > 96) {
          $curcount = $color[$hue];
          $color[$hue] = $curcount + 1;
        }
        $totalS += $s;
        $totalV += $v;

        $Ycounter = $Ycounter - 1;
        $LoopCount = $LoopCount + 1;
      }
      $Xcounter = $Xcounter - 1;
    }
    imagedestroy($simg);
    if (!is_array($color)) {
      $fileName = "images/up_na.gif";
    } else {
      arsort($color);  // color array is formated by index color => number of pixels
      $hueArr = array_keys($color);
      $per = ($color[$hueArr[0]] / $LoopCount) * 100;
      $query = "INSERT INTO {$CONFIG['TABLE_PREFIX']}colors SET pid = {$row['pid']}, aid = {$row['aid']}, hue = {$hueArr[0]}, percent = $per";
      $result1 = mysql_query($query);
      //echo $query;
      if (!$result1) {
        $query = "UPDATE {$CONFIG['TABLE_PREFIX']}colors SET aid = {$row['aid']}, hue = {$hueArr[0]}, percent = $per WHERE pid = {$row['pid']}";
        mysql_query($query);
      }
      /**
      * Image index successful. Show the OK image.
      */
      $fileName = "images/up_ok.gif";
    }
    unset ($color);
    unset($hueArr);
  }
} else {
  /**
   * Picture not found. Show the cross image.
   */
  $fileName = "images/red.gif";
}

header('Content-type: image/gif');
echo fread(fopen($fileName, 'rb'), filesize($fileName));
?>